﻿using EJGrid.Models;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using Syncfusion.JavaScript.Models;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Linq.Expressions;
using System.Web;
using System.Web.Mvc;
using System.Web.UI.WebControls;
using System.Xml;

namespace EJGrid.Controllers
{
    public class HomeController : Controller
    {
        List<Orders> order = new List<Orders>();
        List<EmployeeData> employee = new List<EmployeeData>();
        public ActionResult Index()
        {
            var DataSource2 = BindDataSource();
            ViewBag.dataSource2 = DataSource2;
            return View();
        }
        public List<EmployeeData> BindDataSource()
        {
            employee.Add(new EmployeeData(1, "Michael", "Germany"));
            employee.Add(new EmployeeData(2, "Anne", "Mexico"));
            employee.Add(new EmployeeData(3, "Janet", "UK"));
            employee.Add(new EmployeeData(4, "Andrew", "Sweden"));
            employee.Add(new EmployeeData(5, "Margaret", "Germany"));
            employee.Add(new EmployeeData(6, "Nancy", "France"));
            employee.Add(new EmployeeData(7, "Robert", "Spain"));
            employee.Add(new EmployeeData(8, "Laura", "Canada"));
            employee.Add(new EmployeeData(9, "Steven", "Argentina"));
            employee.Add(new EmployeeData(10, "James", "Switzerland"));
            employee.Add(new EmployeeData(11, "Smith", "Brazil"));
            employee.Add(new EmployeeData(12, "Jhonson", "Austria"));
            employee.Add(new EmployeeData(13, "George", "Italy"));

            return employee;
        }
        public ActionResult DataSource(DataManager dm)
        {
            var DataSource = OrderRepository.GetAllRecords();
            DataResult result = new DataResult();
            result.result = DataSource.Skip(dm.Skip).Take(dm.Take).ToList();
            result.count = DataSource.Count();
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Update(List<Orders> changed, List<Orders> added, List<Orders> deleted)
        {
            if(changed != null)
                OrderRepository.Update(changed);
            if (deleted != null)
                OrderRepository.Delete(deleted);
            if (added != null)
                OrderRepository.Add(added);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
        [Serializable]
        public class EmployeeData
        {
            public EmployeeData()
            {

            }
            public EmployeeData(int EmployeeId, string FirstName, string ShipCountry)
            {
                this.EmployeeID = EmployeeId;
                this.FirstName = FirstName;
                this.ShipCountry = ShipCountry;
            }
            public int EmployeeID { get; set; }
            public string FirstName { get; set; }
            public string ShipCountry { get; set; }
        }
    }
}